/************************************************************************************
 * Copyright (C) 2008 by Politehnica University of Bucharest and Rutgers University
 * All rights reserved.
 * Refer to LICENSE for terms and conditions of use.
 ***********************************************************************************/
package vnsim.core.events;


import java.io.Serializable;
import java.util.LinkedList;

import vnsim.core.*;


/**
 * @author Victor Gradinescu
 *
 */
public class ReceiveEvent extends Event{
	public Communicator sender;
	public Communicator receiver;
	byte[] message;
	
	int messageType;
	
	Serializable messageObject;
	
	public LinkedList<ReceiveEvent> signals = new LinkedList<ReceiveEvent>();
	
	boolean unicast = false;
	
	public boolean isUnicast() {
		return unicast;
	}

	public void setUnicast(boolean unicast) {
		this.unicast = unicast;
	}


	public ReceiveEvent(int t, Communicator receiver, byte[] message, Serializable messageObject, int type){
		super(t);
		signals.add(this);
		this.receiver = receiver;
		this.message = message;
		this.messageObject = messageObject;
		if (messageObject != null) {
			message = new byte[1];
			message[0] = (byte)type;
		}
	}

	public byte[] getMessage() {
		return message;
	}
	public void setMessage(byte[] message) {
		this.message = message;
	}
	
	public Serializable getMessageObject() {
		return messageObject;
	}
	
	public Communicator getReceiver() {
		return receiver;
	}
	public void setReceiver(Communicator receiver) {
		this.receiver = receiver;
	}
	public Communicator getSender() {
		return sender;
	}
	public void setSender(Communicator sender) {
		this.sender = sender;
	}

	public String toString() {
		return "["+time+": Recv "+message+" from "+receiver+" ]";
	} 
	
	
}
